=== added file '.project'
--- .project	1970-01-01 00:00:00 +0000
+++ .project	2006-12-11 06:44:19 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>loggerhead</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.python.pydev.PyDevBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.python.pydev.pythonNature</nature>
+	</natures>
+</projectDescription>

=== modified file 'NEWS'
--- NEWS	2008-08-20 22:34:59 +0000
+++ NEWS	2008-07-26 17:53:10 +0000
@@ -1,24 +1,9 @@
 What's changed in loggerhead?
 =============================
 
-dev [future]
-
-    - Added --port, --host and --prefix options to serve-branches
-      script. (Martin Albisetti)
-
-    - Fixed broken template for project browsing with start-loggerhead
-      (Martin Albisett)
-
-1.6 [15Aug2008]
+1.6 [unreleased]
 ----------------
 
-    - Download a diffs between revisions. (Martin Albisetti)
-
-    - Modified templates to make loggerhead's theme easier to
-      change. (Paul Hummer)
-
-    - Default sqlite interface is now sqlite3. (Robert Collins)
-
     - New ninja theme sponsored by Canonical (Martin Albisetti)
 
     - Added COPYING file and clarified copyright headers (John Arbash Meinel)
@@ -26,15 +11,12 @@
     - Remove the .py extension requiered by the Debian Policy.
       (Jelmer Vernooij)
 
-    - New startup script serve-branches will serve Loggerhead without
-      the need of configuration, and allow you to browse through directories
-      and branches. (Michael Hudson)
-
     - Loggerhead is no longer a TurboGears application, but rather a
       WSGI application built using Paste (see http://wsgi.org/ and
-      http://pythonpaste.org/ for more about WSGI and Paste).
+      http://pythonpaste.org/ for more about WSGI and Paste). XXX more.
 
-    - URLs now use revision numbers instead of revision ids (Martin Albisetti)
+    - zpt.cleaner_urls bug 138021 ("loggerhead should generate links
+      based on revision numbers and file paths").  XXX more.
 
     - The scripts no longer insist on Python 2.4 -- loggerhead works
       fine with 2.5.
@@ -77,6 +59,7 @@
       cache.
 
 1.2  [04mar2008]
+----------------
 
     - Michael Hudson <michael.hudson@canonical.com> has mostly taken
       over the maintenance of loggerhead.

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2008-08-12 19:24:49 +0000
+++ loggerhead/apps/branch.py	2008-07-09 08:39:59 +0000
@@ -17,19 +17,16 @@
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.download_ui import DownloadUI
 from loggerhead.controllers.search_ui import SearchUI
-from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.history import History
 from loggerhead import util
 
 
 class BranchWSGIApp(object):
 
-    def __init__(self, branch, friendly_name=None, config={},
-                 graph_cache=None, branch_link=None):
+    def __init__(self, branch, friendly_name=None, config={}, graph_cache=None):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
-        self.branch_link = branch_link  # Currently only used in Launchpad
         self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
         if graph_cache is None:
             graph_cache = bzrlib.lru_cache.LRUCache()
@@ -79,7 +76,6 @@
         'download': DownloadUI,
         'atom': AtomUI,
         'search': SearchUI,
-        'diff': DiffUI,
         }
 
     def last_updated(self):

=== modified file 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/filesystem.py	2008-08-05 05:11:33 +0000
+++ loggerhead/apps/filesystem.py	2008-07-26 18:39:49 +0000
@@ -1,31 +1,50 @@
 """Serve branches at urls that mimic the file system layout."""
 
+import cgi
 import os
 import tempfile
 
 from bzrlib import branch, errors, lru_cache
 
 from paste.request import path_info_pop
+from paste.wsgiwrappers import WSGIRequest, WSGIResponse
 from paste import httpexceptions
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, static_app
-from loggerhead.controllers.directory_ui import DirectoryUI
 
 sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
 
 
+class DirectoryListing(object):
+
+    def __init__(self, path):
+        self.path = path
+
+    def __call__(self, environ, start_response):
+        request = WSGIRequest(environ)
+        response = WSGIResponse()
+        listing = [d for d in os.listdir(self.path) if not d.startswith('.')]
+        response.headers['Content-Type'] = 'text/html'
+        print >> response, '<html><body>'
+        for d in sorted(listing):
+            if os.path.isdir(os.path.join(self.path, d)):
+                d = cgi.escape(d)
+                print >> response, '<li><a href="%s/">%s</a></li>' % (d, d)
+        print >> response, '</body></html>'
+        return response(environ, start_response)
+
+
 class BranchesFromFileSystemServer(object):
-    def __init__(self, path, root, name=None):
-        self.path = path
+    def __init__(self, folder, root):
+        self.folder = folder
         self.root = root
-        self.name = name
 
     def app_for_branch(self, branch):
-        if not self.name:
-            name = branch.nick
+        if not self.folder:
+            name = os.path.basename(os.path.abspath(self.root.folder))
         else:
-            name = self.name
+            name = self.folder
         branch_app = BranchWSGIApp(
             branch, name, {'cachepath': sql_dir}, self.root.graph_cache)
         return branch_app.app
@@ -36,24 +55,17 @@
             raise httpexceptions.HTTPMovedPermanently(
                 environ['SCRIPT_NAME'] + '/')
         elif segment == '':
-            if self.name:
-                name = self.name
-            else:
-                name = '/'
-            return DirectoryUI(environ['loggerhead.static.url'], self.path, name)
+            return DirectoryListing(os.path.join(self.root.folder, self.folder))
         else:
-            new_path = os.path.join(self.path, segment)
-            if self.name:
-                new_name = os.path.join(self.name, segment)
-            else:
-                new_name = '/' + segment
-            return BranchesFromFileSystemServer(new_path, self.root, new_name)
+            relpath = os.path.join(self.folder, segment)
+            return BranchesFromFileSystemServer(relpath, self.root)
 
     def __call__(self, environ, start_response):
-        if not os.path.isdir(self.path):
+        path = os.path.join(self.root.folder, self.folder)
+        if not os.path.isdir(path):
             raise httpexceptions.HTTPNotFound()
         try:
-            b = branch.Branch.open(self.path)
+            b = branch.Branch.open(path)
         except errors.NotBranchError:
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
@@ -76,33 +88,4 @@
             return favicon_app(environ, start_response)
         else:
             return BranchesFromFileSystemServer(
-                self.folder, self)(environ, start_response)
-
-
-class UserBranchesFromFileSystemRoot(object):
-
-    def __init__(self, folder, trunk_dir):
-        self.graph_cache = lru_cache.LRUCache()
-        self.folder = folder
-        self.trunk_dir = trunk_dir
-
-    def __call__(self, environ, start_response):
-        environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info= environ['PATH_INFO']
-        if path_info.startswith('/static/'):
-            segment = path_info_pop(environ)
-            assert segment == 'static'
-            return static_app(environ, start_response)
-        elif path_info == '/favicon.ico':
-            return favicon_app(environ, start_response)
-        else:
-            # segments starting with ~ are user branches
-            if path_info.startswith('/~'):
-                segment = path_info_pop(environ)
-                new_path = os.path.join(self.folder, segment[1:])
-                return BranchesFromFileSystemServer(
-                    new_path, self, segment)(environ, start_response)
-            else:
-                new_path = os.path.join(self.folder, self.trunk_dir)
-                return BranchesFromFileSystemServer(
-                    new_path, self)(environ, start_response)
+                '', self)(environ, start_response)

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2008-07-31 05:41:42 +0000
+++ loggerhead/changecache.py	2008-07-22 00:40:03 +0000
@@ -33,11 +33,15 @@
 
 with_lock = util.with_lock('_lock', 'ChangeCache')
 
-SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite3')
+SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite')
 
-if SQLITE_INTERFACE == 'sqlite3':
-    from sqlite3 import dbapi2
+if SQLITE_INTERFACE == 'pysqlite2':
+    from pysqlite2 import dbapi2
     _param_marker = '?'
+elif SQLITE_INTERFACE == 'sqlite':
+    import sqlite as dbapi2
+    _param_marker = '%s'
+
 
 _select_stmt = ("select data from revisiondata where revid = ?"
                 ).replace('?', _param_marker)

=== removed file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2008-08-14 02:49:52 +0000
+++ loggerhead/controllers/diff_ui.py	1970-01-01 00:00:00 +0000
@@ -1,99 +0,0 @@
-# Copyright (C) 2008  Canonical Ltd.
-#                     (Authored by Martin Albisetti <argentina@gmail.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-from cStringIO import StringIO
-import logging
-import time
-import sys
-
-from paste import httpexceptions
-from paste.request import path_info_pop
-
-from loggerhead import history
-from loggerhead import util
-from loggerhead.templatefunctions import templatefunctions
-
-import bzrlib
-from bzrlib import branch
-from bzrlib.diff import show_diff_trees
-
-
-log = logging.getLogger("loggerhead.controllers")
-
-class DiffUI(object):
-    """
-
-    Class to output a diff for a single file or revisions.
-    """
-    
-    def __init__(self, branch, history):
-        self._branch = branch
-        self._history = history
-        self.log = history.log
-
-    
-    def __call__(self, environ, start_response):
-        # /diff/<rev_id>/<rev_id>
-        """
-        Default method called from /diff URL.
-        """
-
-        z = time.time()
-        
-        args = []
-        while 1:
-            arg = path_info_pop(environ)
-            if arg is None:
-                break
-            args.append(arg)
-
-        revid_from = args[0]
-        # Convert a revno to a revid if we get a revno
-        revid_from = self._history.fix_revid(revid_from)
-        change = self._history.get_changes([revid_from])[0]
-
-        if len(args) is 2:
-            revid_to = self._history.fix_revid(args[1])
-        else:
-            revid_to = change.parents[0].revid 
-
-
-        repo = self._branch.branch.repository
-        revtree1 = repo.revision_tree(revid_from)
-        revtree2 = repo.revision_tree(revid_to)
-        
-        diff_content_stream = StringIO()
-        show_diff_trees(revtree1, revtree2, diff_content_stream, 
-                        old_label='', new_label='')
-
-        content = diff_content_stream.getvalue()
-
-        self.log.info('/diff %r:%r in %r secs' % (revid_from, revid_to, 
-                                                  time.time() - z))
-
-        revno1 = self._history.get_revno(revid_from)
-        revno2 = self._history.get_revno(revid_to)
-        filename = '%s_%s.diff' % (revno1, revno2)
-        headers = [
-            ('Content-Type', 'application/octet-stream'),
-            ('Content-Length', len(content)),
-            ('Content-Disposition', 'attachment; filename=%s'%(filename,)),
-            ]
-        start_response('200 OK', headers)
-        return [content]
-

=== removed file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2008-08-06 21:25:24 +0000
+++ loggerhead/controllers/directory_ui.py	1970-01-01 00:00:00 +0000
@@ -1,77 +0,0 @@
-# Copyright (C) 2008  Canonical Ltd.
-#                     (Authored by Martin Albisetti <argentina@gmail.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-import datetime
-import logging
-import os
-
-from bzrlib import branch
-
-from loggerhead.controllers import TemplatedBranchView
-
-class DirEntry(object):
-    def __init__(self, dirname, parity, branch):
-        self.dirname = dirname
-        self.parity = parity
-        self.branch = branch
-        if branch is not None:
-            # If a branch is empty, bzr raises an exception when trying this
-            try:
-                self.last_change =  datetime.datetime.fromtimestamp(
-                    branch.repository.get_revision(branch.last_revision()).timestamp)
-            except:
-                self.last_change = None
-
-class DirectoryUI(TemplatedBranchView):
-    """
-    """
-
-    template_path = 'loggerhead.templates.directory'
-
-    def __init__(self, static_url_base, path, name):
-        class _branch(object):
-            context_url = 1
-        self._branch = _branch
-        self._history = None
-        self._path = path
-        self._name = name
-        self._static_url_base = static_url_base
-        self.log = logging.getLogger('')
-
-    def get_values(self, h, args, kwargs, response):
-        listing = [d for d in os.listdir(self._path)
-                   if not d.startswith('.')
-                   and os.path.isdir(os.path.join(self._path, d))]
-        listing.sort(key=lambda x: x.lower())
-        dirs = []
-        parity = 0
-        def static_url(path):
-            return self._static_url_base + path
-        for d in listing:
-            p = os.path.join(self._path, d)
-            try:
-                b = branch.Branch.open(p)
-            except:
-                b = None
-            dirs.append(DirEntry(d, parity, b))
-            parity = 1 - parity
-        return {
-            'dirs': dirs,
-            'name': self._name,
-            'static_url': static_url,
-            }

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-08-12 16:36:23 +0000
+++ loggerhead/history.py	2008-07-26 17:53:10 +0000
@@ -257,19 +257,13 @@
             revid = parents[0]
 
     def get_short_revision_history_by_fileid(self, file_id):
+        # wow.  is this really the only way we can get this list?  by
+        # man-handling the weave store directly? :-0
         # FIXME: would be awesome if we could get, for a folder, the list of
-        # revisions where items within that folder changed.i
-        try:
-            # FIXME: Workaround for bzr versions prior to 1.6b3. 
-            # Remove me eventually pretty please  :)
-            w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
-            w_revids = w.versions() 
-            revids = [r for r in self._full_history if r in w_revids] 
-        except AttributeError:
-            possible_keys = [(file_id, revid) for revid in self._full_history]
-            existing_keys = self._branch.repository.texts.get_parent_map(possible_keys)
-            revids = [revid for _, revid in existing_keys.iterkeys()]
-        return revids
+        # revisions where items within that folder changed.
+        possible_keys = [(file_id, revid) for revid in self._full_history]
+        existing_keys = self._branch.repository.texts.get_parent_map(possible_keys)
+        return [revid for _, revid in existing_keys.iterkeys()]
 
     def get_revision_history_since(self, revid_list, date):
         # if a user asks for revisions starting at 01-sep, they mean inclusive,

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2008-08-05 19:44:50 +0000
+++ loggerhead/static/css/annotate.css	2008-07-24 22:00:49 +0000
@@ -1,13 +1,16 @@
 /*table*/
 .annoLineTit, .annoLine, .annoRevTit, .annoRev, .annoComm, .annoCommTit, .annoContTit, .annoCont {
+	padding:4px;
 	width:45px;
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
+	padding:5px 0px;
 	border:none;	
 }
 .annoLine {
 	width:37px;
+	padding:5px 4px;
 }
 .annoContTit, .annoCont {
 	width:auto;

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2008-08-13 17:33:41 +0000
+++ loggerhead/static/css/global.css	2008-07-25 19:23:15 +0000
@@ -18,11 +18,11 @@
 	outline:none;
 }
 form {
-  margin: 0;
-  padding: 0;
+	margin:0;
+	padding:0;
 }
 tr td {
-  vertical-align: top;
+    vertical-align:top
 }
 .clear {
 	clear:both;
@@ -120,7 +120,7 @@
 #finderBox {
 	width:300px;
 	float:right;
-	padding: 10px 0px 0px 0px;
+	padding:0px;
 }
 #finderBox label {
 	float:left;
@@ -186,6 +186,7 @@
 	padding:0px 11px 0px 0px;
 	margin:0px 2px 0px 0px;
 	font-weight:bold;
+	background:url(../images/ico_link.gif) right top no-repeat;
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
@@ -227,15 +228,15 @@
 .expandcell, .expcell {
 	width:28px;	
 }
-.summarycell, .authorcell, .datecell, .timedate{
-  padding: 4px 8px;
-  border: 1px solid #d2d2d2;
+.summarycell, .authorcell, .datecell, .summcell, .autcell, .date, .timedate, .timedate2 {
+	padding:4px 8px;
+	border:1px solid #d2d2d2;
 }
-.icocell {
-  width: 18px;
+.authorcell, .autcell {
+	width:202px;
 }
 .datecell, .date {
-  width: 180px;
+	width:110px;
 }
 .timedate, .timedate2 {
 	width:80px;
@@ -243,10 +244,9 @@
 .downloadcell, .downr {
 	width:47px;
 }
-.revnro, .expcell, .diffr, .summcell, .autcell, .icocell, .date, .downr, .allicones, .timedate2 {
-  border: 0;
-  padding: 4px 4px;
-  border-bottom:1px solid #d2d2d2;
+.revnro, .expcell, .diffr, .summcell, .autcell, .date, .downr, .allicones, .timedate2 {
+	border:none;
+	border-bottom:1px solid #d2d2d2;
 }
 .revisioninfo {
     margin-top:4px;

=== removed file 'loggerhead/static/images/ico_branch.gif'
Binary files loggerhead/static/images/ico_branch.gif and loggerhead/static/images/ico_branch.gif differ
=== removed file 'loggerhead/static/images/ico_folder_up.gif'
Binary files loggerhead/static/images/ico_folder_up.gif and loggerhead/static/images/ico_folder_up.gif differ
=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2008-08-14 20:31:07 +0000
+++ loggerhead/static/javascript/custom.js	2008-07-22 00:40:03 +0000
@@ -4,7 +4,6 @@
 window.addEvent('domready', function() 
 {
     var search_box = $('q');
-    search_box.removeEvents();
     search_box.addEvents(
     {
         keyup: function()
@@ -15,10 +14,10 @@
             }
             else
             {
-                if (null != global_timeout_id)
-                {
-                    clearTimeout(global_timeout_id);
-                }
+	            if (null != global_timeout_id)
+	            {
+	                clearTimeout(global_timeout_id);
+	            }
                     global_timeout_id = setTimeout('$("q").fireEvent("search",$("q").value)',200);
             }
         },
@@ -26,25 +25,21 @@
         search: function(query)
         {
             url = global_path + 'search?query=' + query;
-
+	
             if ($defined(global_search_request))
             {
                 global_search_request.cancel();
             }
-            global_search_request = new Request({'url':url,'method':'get','onComplete':function(response)
-              {
-                 cool_search(response,query);
-             }});
-
+            global_search_request = new Request({'url':url,'method':'get','onComplete':cool_search});
             global_search_request.send('');
-            var posicion = search_box.getPosition();
-            var size     = search_box.getSize();
+	        var posicion = search_box.getPosition();
+	        var size     = search_box.getSize();
 
-            $('search_terms').setStyle('position','absolute');
-            $('search_terms').setStyle('left',posicion.x);
-            $('search_terms').setStyle('top',posicion.y + size.y);
-            $('search_terms').setStyle('display','block');
-            $('search_terms').set('html','Loading...');
+	        $('search_terms').setStyle('position','absolute');
+	        $('search_terms').setStyle('left',posicion.x);
+	        $('search_terms').setStyle('top',posicion.y + size.y);
+	        $('search_terms').setStyle('display','block');
+	        $('search_terms').set('html','Loading...');
 
             new Request({'url':url,'method':'get','onComplete':cool_search}).send('');
 
@@ -53,19 +48,15 @@
     });
 });
 
-function cool_search(response, query)
+function cool_search(response)
 {
 	var posicion = $('q').getPosition();
 	var size     = $('q').getSize();
-    var current_query = $('q').get('value');
-    if (current_query == query)
-    {
-	    $('search_terms').set('html',response);
-	    $('search_terms').setStyle('display','block');
-	    $('search_terms').setStyle('position','absolute');
-	    $('search_terms').setStyle('left',posicion.x);
-	    $('search_terms').setStyle('top',posicion.y + size.y);
-    }
+	$('search_terms').set('html',response);
+	$('search_terms').setStyle('display','block');
+	$('search_terms').setStyle('position','absolute');
+	$('search_terms').setStyle('left',posicion.x);
+	$('search_terms').setStyle('top',posicion.y + size.y);
 }
 
 function hide_search()

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2008-08-13 19:51:08 +0000
+++ loggerhead/templatefunctions.py	2008-07-26 14:52:44 +0000
@@ -74,17 +74,3 @@
     return _pt('modified-file-link-log').expand(
         url=url, entry=entry, item=item,
         **templatefunctions)
-
-@templatefunc
-def search_box(branch, navigation):
-    return _pt('search-box').expand(branch=branch, navigation=navigation,
-        **templatefunctions)
-
-@templatefunc
-def feed_link(branch, url):
-    return _pt('feed-link').expand(branch=branch, url=url, **templatefunctions)
-
-@templatefunc
-def menu(branch, url, fileview_active=False):
-    return _pt('menu').expand(branch=branch, url=url,
-        fileview_active=fileview_active, **templatefunctions)

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2008-08-04 03:42:01 +0000
+++ loggerhead/templates/annotate.pt	2008-07-23 23:00:16 +0000
@@ -15,16 +15,8 @@
   <body>
 
     <h1 metal:fill-slot="heading">
-      <tal:has-link condition="branch/branch_link">
-        <a tal:attributes="href branch/branch_link"
-           tal:content="branch/friendly_name">
-          nice/branch/name
-        </a>
-      </tal:has-link>
-      <tal:no-link condition="not: branch/branch_link">
-        <tal:branch-name replace="branch/friendly_name" />
-      </tal:no-link>
-      <span>: <span tal:content="path"></span> (revision <tal:revno content="change/revno"></tal:revno>)</span>
+        <tal:block content="branch/friendly_name"></tal:block>
+        <span>: <span tal:content="path"></span> (revision <tal:revno content="change/revno"></tal:revno>)</span>
     </h1>
 
     <div metal:fill-slot="content">

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2008-08-20 22:32:48 +0000
+++ loggerhead/templates/browse.pt	2008-07-22 20:07:08 +0000
@@ -1,44 +1,56 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
   <head>
-    <title>loggerhead branches</title>
-    <link rel="stylesheet"
-          tal:attributes="href python:branch.static_url('/static/css/global.css')" />
+    <title metal:fill-slot="title">
+      loggerhead branches
+    </title>
   </head>
 
   <body>
-   <div id="loggerheadCont">
-    <div>
+
+    <h1 metal:fill-slot="heading" style="padding-bottom: 1em">
+      <tal:title condition="title" content="title" />
+      <tal:no-title condition="not:title">
+        bazaar branches in loggerhead
+      </tal:no-title>
+    </h1>
+
+    <div metal:fill-slot="content">
       <div class="browse-project"
            tal:repeat="project projects">
-        <h1 tal:content="project/friendly_name" />
+        <div class="browse-project-name"
+             tal:content="project/friendly_name"></div>
+
         <div class="browse-project-description"
              tal:condition="python:len(project.long_description) > 0"
              tal:content="structure project/long_description"></div>
 
-          <table id="logentries">
-            <tr class="logheader">
-              <th class="summarycell" colspan="2">Name</th>
-              <th class="summarycell">Description</th>
-              <th class="datecell" colspan="2">Last change</th>
+        <div class="browse-view">
+          <table>
+            <tr class="heading">
+              <th>Name</th>
+              <th>Description</th>
+              <th>Last change</th>
+              <th />
             </tr>
             <tal:block repeat="view python:views_by_project[project]">
-              <tr tal:attributes="class string:blueRow1">
-                <td class="icocell">
-                  <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" />
-                </td>
-                <td class="autcell">
-                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
-                       tal:content="view/friendly_name" />
-                </td>
-                <td class="autcell"
-                    tal:content="view/description" />
-                <td class="date"
-                    tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'" />
-                <td class="icocell">
+              <tr>
+                <td class="name">
+                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                     tal:content="view/friendly_name">
+                    ${view.friendly_name}
+                  </a>
+                </td>
+                <td class="description"
+                    tal:content="view/description">
+                  ${view.description}
+                </td>
+                <td class="last-update"
+                    tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'"></td>
+                <td class="feed">
                   <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name + '/atom')"
                      title="atom feed">
-                    <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')"
+                    <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')"
                          alt="atom feed" />
                   </a>
                 </td>
@@ -48,13 +60,16 @@
                 </td>
                 <td class="description url" colspan="2">
                   <a tal:attributes="href view/branch_url"
-                     tal:content="view/branch_url" />
+                     tal:content="view/branch_url">
+                    ${view.branch_url}
+                  </a>
                 </td>
               </tr>
             </tal:block>
           </table>
+        </div>
+
       </div>
     </div>
-  </div>
   </body>
 </html>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-08-04 03:42:01 +0000
+++ loggerhead/templates/changelog.pt	2008-07-24 02:40:21 +0000
@@ -14,16 +14,7 @@
     <body>
         <tal:block metal:fill-slot="heading">
          <h1>
-           <tal:has-link condition="branch/branch_link">
-             <a tal:attributes="href branch/branch_link"
-                tal:content="branch/friendly_name">
-               nice/branch/name
-             </a>
-           </tal:has-link>
-           <tal:no-link condition="not: branch/branch_link">
-             <tal:branch-name replace="branch/friendly_name" />
-           </tal:no-link>
-           : changes
+          <tal:block content="branch/friendly_name"></tal:block>: changes
           <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
           <tal:block condition="start_revid">from revision <tal:block content="python:history.get_revno(start_revid)" /></tal:block>
           <tal:block condition="query">matching <tal:block content="query" /></tal:block>

=== removed file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2008-08-05 06:12:07 +0000
+++ loggerhead/templates/directory.pt	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" >
-  <head>
-    <title tal:content="string:Browsing ${name}"></title>
-    <link rel="stylesheet"
-          tal:attributes="href python:static_url('/static/css/global.css')" />
-  </head>
-  <body>
-    <div id="loggerheadCont">
-      <h1 tal:content="string:Browsing ${name}">
-        Hi.
-      </h1>
-
-      <div >
-        <table id="logentries">
-          <tr class="logheader">
-            <th class="summarycell" colspan="2">Filename</th>
-            <th class="datecell">Latest Rev</th>
-            <th class="datecell">Last Changed</th>
-          </tr>
-          
-          <tr class="blueRow0" tal:condition="python:name != '/'">
-            <td class="icocell">
-                <a href=".."><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
-            </td>
-            <td class="summcell" colspan="3">
-                <a href="..">..</a>
-            </td>
-          </tr>
-          <tal:block repeat="dir dirs">
-
-            <tal:branch-row tal:condition="dir/branch">
-              <tr tal:attributes="class string:blueRow${dir/parity}">
-                <td class="icocell">
-                    <a tal:attributes="href string:${dir/dirname}/files">
-                        <img tal:attributes="src python:static_url('/static/images/ico_branch.gif')" />
-                    </a>
-                </td>
-                <td class="autcell">
-                  <a tal:attributes="href string:${dir/dirname}/files" tal:content="dir/dirname" /></td>
-                <td class="date">
-                  <a tal:attributes="href string:${dir/dirname}/revision/${dir/branch/revno};
-                                     title string:Show revision ${dir/branch/revno}"
-                     tal:content="dir/branch/revno"></a>
-                </td>
-                <td class="date" tal:content="python:util.date_time(dir.last_change)"></td>
-              </tr>
-            </tal:branch-row>
-            <tal:non-branch-row tal:condition="not:dir/branch">
-              <tr tal:attributes="class string:blueRow${dir/parity}">
-                <td class="icocell">
-                    <a tal:attributes="href string:${dir/dirname}">
-                        <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" />
-                    </a>
-                </td>
-                <td class="autcell">
-                  <a tal:attributes="href string:${dir/dirname}" tal:content="dir/dirname" /></td>
-                <td class="date"></td>
-                <td class="date" tal:content="dir/last_change"></td>
-              </tr>
-            </tal:non-branch-row>
-          </tal:block>
-        </table>
-      </div>
-    </div>
-  </body>
-</html>

=== removed file 'loggerhead/templates/feed-link.pt'
--- loggerhead/templates/feed-link.pt	2008-08-13 15:18:17 +0000
+++ loggerhead/templates/feed-link.pt	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-<tal:feed-link>
-  <a tal:attributes="href python:url(['/atom']);
-                     title string:RSS feed for ${branch/friendly_name}">
-    <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')" alt="RSS" class="rssfeed"/>
-  </a>
-</tal:feed-link>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-08-06 04:20:07 +0000
+++ loggerhead/templates/inventory.pt	2008-07-25 02:05:12 +0000
@@ -11,17 +11,8 @@
   <body>
 
     <h1 metal:fill-slot="heading">
-      <tal:has-link condition="branch/branch_link">
-        <a tal:attributes="href branch/branch_link"
-           tal:content="branch/friendly_name">
-          nice/branch/name
-        </a>
-      </tal:has-link>
-      <tal:no-link condition="not: branch/branch_link">
-        <tal:branch-name replace="branch/friendly_name" />
-      </tal:no-link>
-      : viewing
-      <span tal:content="path" /> for revision <span tal:content="change/revno"/>
+        <tal:block content="branch/friendly_name" />: viewing 
+        <span><tal:block content="path" /></span> for revision <span><tal:revno content="change/revno"></tal:revno></span>
     </h1>
 
     <div metal:fill-slot="content">
@@ -48,8 +39,7 @@
 
           <tr class="blueRow0" tal:condition="python:updir">
               <td class="summcell" colspan="6">
-                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
-                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
+                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">..</a>
               </td>
           </tr>
           
@@ -64,7 +54,7 @@
                <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
                                       tal:content="file/filename" class="link"></a>
                </td>
-               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
                                                    title string:Show revision ${file/change/revno}"
                                    tal:content="file/change/revno"></a>
                </td>
@@ -87,7 +77,7 @@
                <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
                                       tal:content="file/filename" class="link"></a>
                </td>
-               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
                                                    title string:Show revision ${file/change/revno}"
                                    tal:content="file/change/revno"></a>
                </td>
@@ -116,7 +106,7 @@
 
             <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
                                    tal:content="file/filename" class="link"></a></td>
-            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
                                                 title string:Show revision ${file/change/revno}"
                                 tal:content="file/change/revno"></a>
             </td>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2008-08-19 12:54:33 +0000
+++ loggerhead/templates/macros.pt	2008-07-25 19:23:15 +0000
@@ -21,25 +21,41 @@
 
 <body>
     <!-- Loggerhead Content Area -->
-      <div id="finderBox">
-         <tal:search-box define="navigation navigation"
-                        replace="structure python:search_box(branch,
-                                 navigation)" />
-        <div>
-          <tal:feed-link replace="structure python:feed_link(branch, url)" />
-        </div>
-      </div>
-
-      <tal:menu define="fileview_active fileview_active"
-                replace="structure python:menu(branch, url, fileview_active)" />
+    <ul id="menuTabs">
+        <form tal:attributes="action python:branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), 
+                                                                   file_id=getattr(navigation, 'file_id', None))">
+      	  <div id="finderBox">
+            <label>search:</label> <input type="search" name="q" id="q" autocomplete="off" onblur="hide_search();" /> 
+            <div><a tal:attributes="href python:url(['/atom']);
+                                    title string:RSS feed for ${branch/friendly_name}"> 
+                 <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')" alt="RSS" class="rssfeed"/></a>
+            </div>
+          </div>
+        </form>
+        
+        <tal:block tal:condition="not:fileview_active">
+        <li><a tal:attributes="href python:url('/changes', clear=1);
+                               title string:Changes;
+                               id string:on">Changes</a></li>
+        <li><a tal:attributes="href python:url('/files', clear=1);
+                               title string:Files">Files</a></li>
+        </tal:block>
+        <tal:block tal:condition="fileview_active">
+        <li><a tal:attributes="href python:url('/changes', clear=1);
+                               title string:Changes">Changes</a></li>
+        <li><a tal:attributes="href python:url('/files', clear=1);
+                               title string:Files;
+                               id string:on">Files</a></li>
+        </tal:block>
+      </ul>
       <div id="loggerheadCont">
-
-        <div id="search_terms"></div>
+    
+         <div id="search_terms"></div>
 
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
-        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/" class="link">Bazaar</a> branches</p>
-      </div>
+        <p class="fl">Loggerhead runs on <a href="http://bazaar-vcs.org/" class="link">Bazaar</a> branches</p>
+    </div>
   </body>
 </html>

=== removed file 'loggerhead/templates/menu.pt'
--- loggerhead/templates/menu.pt	2008-08-13 17:33:41 +0000
+++ loggerhead/templates/menu.pt	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-<tal:menu>
-    <ul id="menuTabs">
-        <tal:changes-active tal:condition="not:fileview_active">
-        <li><a tal:attributes="href python:url('/changes', clear=1);
-                               title string:Changes;
-                               id string:on">Changes</a></li>
-        <li><a tal:attributes="href python:url('/files', clear=1);
-                               title string:Files">Files</a></li>
-        </tal:changes-active>
-        <tal:fileview-active tal:condition="fileview_active">
-        <li><a tal:attributes="href python:url('/changes', clear=1);
-                               title string:Changes">Changes</a></li>
-        <li><a tal:attributes="href python:url('/files', clear=1);
-                               title string:Files;
-                               id string:on">Files</a></li>
-        </tal:fileview-active>
-      </ul>
-</tal:menu>
-

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-08-16 06:34:03 +0000
+++ loggerhead/templates/revision.pt	2008-07-24 00:17:48 +0000
@@ -15,17 +15,7 @@
     <body>
 
       <tal:block metal:fill-slot="heading">
-        <h1>
-          <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
-              nice/branch/name
-            </a>
-          </tal:has-link>
-          <tal:no-link condition="not: branch/branch_link">
-            <tal:branch-name replace="branch/friendly_name" />
-          </tal:no-link>
-          <span>: <tal:revno content="change/revno"></tal:revno>
+        <h1><tal:block content="branch/friendly_name" /><span>: <tal:revno content="change/revno"></tal:revno>
         <tal:compare-to condition="python:compare_revid is not None">
           (compared to revision <tal:block content="python:history.get_revno(compare_revid)" />)
           </tal:compare-to>
@@ -36,19 +26,13 @@
                                tal:content="string:browse files at revision ${change/revno}"></a></li>
             <li tal:condition="python:remember != change.revno">
                 <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None); 
-                                   title string:compare with another revision"
+                                   title string:Compare with another revision"
                    tal:content="string:Compare with another revision"></a></li>       
             <li tal:condition="python:(remember is not None) and (compare_revid is None) and (change.revno != remember)" >
                 <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
                 compare with revision <tal:b content="python:history.get_revno(remember)" />
                 </a>
             </li>
-            <li>
-            <a tal:condition="python:len(change.parents) > 0 and compare_revid is None"
-                   tal:attributes="href python:url(['/diff', change.revno], clear=1)">download diff</a>
-            <a tal:condition="python:compare_revid is not None"
-                   tal:attributes="href python:url(['/diff', change.revno, history.get_revno(compare_revid)], clear=1)">download diff</a>
-            </li>
             <li id="last"><a tal:attributes="href python:url(['/changes', change.revno]); 
                                   title string:view history from revision ${change/revno}"
                   tal:content="string:view history from revision ${change/revno}"></a></li>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2008-08-05 19:25:28 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-07-25 02:06:37 +0000
@@ -13,7 +13,7 @@
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
+        <div class="information" tal:content="change/comment"></div>
     </div>
     <ul id="list-files">
         <tal:block condition="nocall:modified_file_link">

=== removed file 'loggerhead/templates/search-box.pt'
--- loggerhead/templates/search-box.pt	2008-08-13 17:24:10 +0000
+++ loggerhead/templates/search-box.pt	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-<tal:search-box>
-  <form tal:attributes="action python:branch.url('/changes',
-                            start_revid=getattr(navigation,
-                            'start_revid', None),
-                            file_id=getattr(navigation, 'file_id', None))">
-    <label>search:</label>
-    <input type="search" name="q" id="q" autocomplete="off" onblur="hide_search();" />
-  </form>
-</tal:search-box>
-

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-08-06 21:25:24 +0000
+++ loggerhead/util.py	2008-07-26 17:53:10 +0000
@@ -59,10 +59,7 @@
 
 
 def date_time(value):
-    if value is not None:
-        return value.strftime('%Y-%m-%d %T')
-    else:
-        return 'N/A'
+    return value.strftime('%Y-%m-%d %T')
 
 
 def _displaydate(date):

=== modified file 'serve-branches'
--- serve-branches	2008-08-20 22:11:54 +0000
+++ serve-branches	2008-07-26 17:41:49 +0000
@@ -16,102 +16,36 @@
 """Search for branches underneath a directory and serve them all."""
 
 import logging
-import os
 import sys
 
-from optparse import OptionParser
-
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler
 from paste.translogger import TransLogger
 
-from loggerhead import __version__
-from loggerhead.apps.filesystem import (
-    BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
-
-
-def command_line_parser():
-    parser = OptionParser("%prog [options] <path>")
-    parser.set_defaults(
-        user_dirs=False,
-        show_version=False,
-        )
-    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
-                      help="Serve user directories as ~user.")
-    parser.add_option("--trunk-dir", metavar="DIR",
-                      help="The directory that contains the trunk branches.")
-    parser.add_option("--port", dest="user_port",
-                      help="Port Loggerhead should listen on. 8080 is the default one.")
-    parser.add_option("--host", dest="user_host",
-                      help="Host Loggerhead should listen on.")
-    parser.add_option("--prefix", dest="user_prefix",
-                      help="Specify host prefix.")
-    parser.add_option("--version", action="store_true", dest="show_version",
-                      help="Print the software version and exit")
-    return parser
-
-
-def main(args):
-    logging.basicConfig()
-    logging.getLogger().setLevel(logging.DEBUG)
-
-    parser = command_line_parser()
-    (options, args) = parser.parse_args(sys.argv[1:])
-
-    if options.show_version:
-        print "loggerhead %s" % __version__
-        sys.exit(0)
-
-    if len(args) > 1:
-        parser.print_help()
-        sys.exit(1)
-    elif len(args) == 1:
-        [path] = args
-    else:
-        path = '.'
-
-    if not os.path.isdir(path):
-        print "%s is not a directory" % path
-        sys.exit(1)
-
-    if options.trunk_dir and not options.user_dirs:
-        print "--trunk-dir is only valid with --user-dirs"
-        sys.exit(1)
-
-    if options.user_dirs:
-        if not options.trunk_dir:
-            print "You didn't specify a directory for the trunk directories."
-            sys.exit(1)
-        app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
-    else:
-        app = BranchesFromFileSystemRoot(path)
-    app = HTTPExceptionHandler(app)
-    app = TransLogger(app)
-
-    if not options.user_prefix:
-        prefix = '/'
-    else:
-        prefix = options.user_prefix
-
-    try:
-        from paste.deploy.config import PrefixMiddleware
-    except ImportError:
-        pass
-    else:
-        app = PrefixMiddleware(app, prefix=prefix)
-    
-    if not options.user_port:
-        port = '8080'
-    else:
-        port = options.user_port
-
-    if not options.user_host:
-        host = '0.0.0.0'
-    else:
-        host = options.user_host
-
-    httpserver.serve(app, host=host, port=port)
-
-
-if __name__ == "__main__":
-    main(sys.argv)
+from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
+
+
+logging.basicConfig()
+logging.getLogger().setLevel(logging.DEBUG)
+
+if len(sys.argv) > 1:
+    path = sys.argv[1]
+else:
+    path = '.'
+
+app = BranchesFromFileSystemRoot(path)
+
+app = HTTPExceptionHandler(app)
+app = TransLogger(app)
+
+try:
+    from paste.deploy.config import PrefixMiddleware
+except ImportError:
+    pass
+else:
+    app = PrefixMiddleware(app)
+
+#from paste.evalexception import EvalException
+#app = EvalException(app)
+
+httpserver.serve(app, host='0.0.0.0', port='8080')

=== removed file 'serve-branches.1'
--- serve-branches.1	2008-08-05 16:07:16 +0000
+++ serve-branches.1	1970-01-01 00:00:00 +0000
@@ -1,29 +0,0 @@
-.TH LOGGERHEAD "1" "August 2008" "loggerhead 1.6" "User Commands"
-.SH NAME
-loggerhead \- run a loggerhead server
-.SH SYNOPSIS
-.B serve-branches
-[\fIoptions\fR] \fI<path>\fR
-.SH DESCRIPTION
-Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
-a branch history, annotate files, view patches, perform searches, etc. It's 
-heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
-.PP
-The serve-branches command runs a standalone loggerhead server in the foreground.
-.SH OPTIONS
-.TP
-\fB\-h\fR, \fB\-\-help\fR
-show this help message and exit
-.TP
-\fB\-\-user\-dirs\fR
-Serve user directories as ~user.
-.TP
-\fB\-\-trunk\-dir\fR=\fIDIR\fR
-The directory that contains the trunk branches.
-.TP
-\fB\-\-version\fR
-Print the software version and exit
-.SH "LICENSE"
-GNU GPLv2 or later.
-.SH "SEE ALSO"
-https://launchpad.net/loggerhead

=== modified file 'setup.py'
--- setup.py	2008-08-05 16:02:23 +0000
+++ setup.py	2008-07-31 04:49:15 +0000
@@ -31,17 +31,10 @@
     maintainer = "Michael Hudson",
     maintainer_email = "michael.hudson@canonical.com",
     scripts = ["start-loggerhead", "stop-loggerhead", "serve-branches"],
-    packages = ["loggerhead", 
-                "loggerhead/apps", 
-                "loggerhead/controllers", 
-                "loggerhead/templates"],
-    package_data = {"loggerhead":["templates/*.pt", 
-                                  "static/css/*.css", 
-                                  "static/javascript/*", 
-                                  "static/images/*"]},
+    packages = ["loggerhead"],
+    package_data = {"loggerhead":["templates/*.pt"]},
     data_files = [
-        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1', 
-                           'serve-branches.1']),
+        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1']),
         ('share/doc/loggerhead', ['loggerhead.conf.example']),
         ],
     )

=== modified file 'start-loggerhead'
--- start-loggerhead	2008-08-11 20:09:44 +0000
+++ start-loggerhead	2008-07-26 17:53:10 +0000
@@ -29,24 +29,25 @@
 from paste.httpexceptions import make_middleware
 from paste.translogger import make_filter
 
-from loggerhead import daemon
+from loggerhead import daemon, release
 from loggerhead.apps.config import Root
 
 
 def make_handler(config, filename):
     roll = config.get('log.roll', 'never')
     if roll == 'daily':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 1, 100)
+        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
     elif roll == 'weekly':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 1, 100)
+        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
     else:
         h = logging.FileHandler(filename)
     return h
 
 
-def setup_logging(log_folder, config, foreground):
+def setup_logging(home, config, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
+    log_folder = os.path.join(home, 'logs')
     if not os.path.exists(log_folder):
         os.mkdir(log_folder)
 
@@ -75,37 +76,33 @@
 
 
 def main():
-    home = os.path.realpath(os.path.dirname(__file__))
-    default_pidfile = os.path.join(home, 'loggerhead.pid')
-    default_configfile = os.path.join(home, 'loggerhead.conf')
-    default_log_folder = os.path.join(home, 'logs')
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog')
+    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
     parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
                       help="run in the foreground; don't daemonize")
     parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
                       help="only start if not already running (useful for cron jobs)")
-    parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
-                      type=str, help="override pidfile location")
-    parser.add_option('-c', '--config-file', dest="configfile", default=default_configfile,
-					  type=str, help="override configuration file location")
-    parser.add_option('-L', '--log-folder', dest="log_folder", default=default_log_folder,
-                      type=str, help="override log file directory")
     options, args = parser.parse_args()
     if len(args) > 0:
         parser.error('No filename arguments are used, only options.')
 
+
+    home = os.path.realpath(os.path.dirname(__file__))
+    pidfile = os.path.join(home, 'loggerhead.pid')
+
     if options.check:
-        if daemon.is_running(options.pidfile):
+        if daemon.is_running(pidfile):
             sys.exit(0)
-        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (options.pidfile,))
+        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
 
     # read loggerhead config
 
-    config = ConfigObj(options.configfile, encoding='utf-8')
+    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
     extra_path = config.get('bzrpath', None)
     if extra_path:
         sys.path.insert(0, extra_path)
 
+    #turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
     potential_overrides = [ ('server.socket_port', int),
                             ('server.webpath', str),
                             ('server.thread_pool', int),
@@ -119,16 +116,17 @@
         value = config.get(key, None)
         if value is not None:
             value = keytype(value)
+            #turbogears.config.update({ key: value })
 
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
+        sys.stderr.write('PID file: %s\n' % (pidfile,))
         sys.stderr.write('\n')
 
-        daemon.daemonize(options.pidfile, home)
+        daemon.daemonize(pidfile, home)
 
-    setup_logging(options.log_folder, config, foreground=options.foreground)
+    setup_logging(home, config, foreground=options.foreground)
 
     log = logging.getLogger('loggerhead')
     log.info('Starting up...')
@@ -153,7 +151,7 @@
     finally:
         log.info('Shutdown.')
         try:
-            os.remove(options.pidfile)
+            os.remove(pidfile)
         except OSError:
             pass
 

=== modified file 'start-loggerhead.1'
--- start-loggerhead.1	2008-08-06 18:33:20 +0000
+++ start-loggerhead.1	2008-07-26 14:09:59 +0000
@@ -23,15 +23,6 @@
 .TP
 \fB\-C\fR, \fB\-\-check\fR
 only start if not already running (useful for cron jobs)
-.TP
-\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
-override pid file location
-.TP
-\fB\-c\fR, \fB\-\-config-file=CONFIGFILE\fR
-override configuration file location
-.TP
-\fB\-L\fR, \fB\-\-log-folder=LOG-FOLDER\fR
-override log directory
 .SH "LICENSE"
 GNU GPLv2 or later.
 .SH "SEE ALSO"

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2008-08-06 19:38:14 +0000
+++ stop-loggerhead	2008-07-26 14:52:44 +0000
@@ -15,24 +15,19 @@
 
 """A script for stopping the loggerhead process."""
 
+import pkg_resources
+pkg_resources.require("TurboGears")
+
 import os
 import sys
-from optparse import OptionParser
 
 home = os.path.realpath(os.path.dirname(__file__))
-default_pidfile = os.path.join(home, 'loggerhead.pid')
-parser = OptionParser(usage='usage: %prog [options]', version='%prog')
-parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
-				  help="override pidfile location")
-
-options, args = parser.parse_args()
-if len(args) > 0:
-	parser.error('No filename arguments are used, only options.')
+pidfile = os.path.join(home, 'loggerhead.pid')
 
 try:
-    f = open(options.pidfile, 'r')
+    f = open(pidfile, 'r')
 except IOError, e:
-    print 'Pid file %s not found.' % options.pidfile
+    print 'No pid file found.'
     sys.exit(1)
 
 pid = int(f.readline())

=== modified file 'stop-loggerhead.1'
--- stop-loggerhead.1	2008-08-06 18:39:15 +0000
+++ stop-loggerhead.1	2008-07-26 14:09:59 +0000
@@ -7,10 +7,6 @@
 Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc. It's 
 heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
-.SH OPTIONS
-.TP
-\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
-override pid file location
 .PP
 The stop-loggerhead command stops the currently running loggerhead server.
 .SH "LICENSE"

